import _extends from "@babel/runtime/helpers/extends";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";

/**
 * @license
 * Copyright © 2017-2019 Moov Corporation.  All rights reserved.
 */
import React, { useState, useContext } from 'react';
import ReactVisibilitySensor from 'react-visibility-sensor';
import withStyles from '@material-ui/core/styles/withStyles';
import classnames from 'classnames';
import AppContext from './AppContext';
export var styles = function styles() {
  return {
    root: {
      minHeight: 10
    }
  };
};
/**
 * Lazy loads its children when the user scrolls near it
 *
 * Props are passed through to the container element
 *
 * @param {ReactChildren} props.children React elements to be loaded lazy
 */

function Lazy(_ref) {
  var children = _ref.children,
      className = _ref.className,
      classes = _ref.classes,
      otherProps = _objectWithoutProperties(_ref, ["children", "className", "classes"]);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      visible = _useState2[0],
      setVisible = _useState2[1];

  var appContext = useContext(AppContext);
  return React.createElement(ReactVisibilitySensor, {
    onChange: function onChange(v) {
      return setVisible(!appContext.scrollResetPending && (visible || v));
    },
    active: !visible,
    partialVisibility: true
  }, React.createElement("div", _extends({
    className: classnames(classes.root, className)
  }, otherProps), visible && children));
}

export default withStyles(styles, {
  name: 'RSFLazy'
})(Lazy);
//# sourceMappingURL=Lazy.js.map